    function R = frame(angles)
% makes a rotation matrix (from quaternion or euler angles, whatever we get)
    %R = makeRotationMatrix(angles(4), angles(5), angles(6));
    R = quat2rot(angles(4:7));    
end


function m=quat2rot(q)
% converts a quaternion to a rotation matrix
% q = [q0 qx qy qz]
	mx = [[(q(1)*q(1) + q(2)*q(2) - q(3)*q(3) - q(4)*q(4)), ...
          2*(q(2)*q(3) - q(1)*q(4)), ...
          2*(q(2)*q(4) + q(1)*q(3))]; ...
         [2*(q(3)*q(2) + q(1)*q(4)), ...
          (q(1)*q(1) - q(2)*q(2) + q(3)*q(3) - q(4)*q(4)), ...
          2*(q(3)*q(4) - q(1)*q(2))]; ...
         [2*(q(4)*q(2) - q(1)*q(3)), ...
          2*(q(4)*q(3) + q(1)*q(2)), ...
          (q(1)*q(1) - q(2)*q(2) - q(3)*q(3) + q(4)*q(4))]];
      
%  m = ( [mx(:,1), -mx(:,3), mx(:,2)] )'; % this modification is weird, but it works
   m = mx';  % works this way, too :-)
end


function R = makeRotationMatrix(azimuth, elevation, roll)
% converts euler angles to a rotation matrix
  R = rotx(-azimuth/180*pi)*roty(-elevation/180*pi)*rotz(-roll/180*pi);
end

function m=rotx(angle)
s=sin(angle);
c=cos(angle);
m = [ 1  0  0;
      0  c -s;
      0  s  c];
end

function m=roty(angle)
s=sin(angle);
c=cos(angle);
m = [ c  0 -s;
      0  1  0;
      -s  0  c];
end

function m=rotz(angle)
s=sin(angle);
c=cos(angle);
m = [ c -s  0;
      s  c  0;
      0  0  1];
end