function G = inferBoneGraph(raw, n, from, to)

G = zeros(n);

for jointA = 1:n
    for jointB = jointA+1:n
        
        %% very slow!
        %Q=[];
        %d=[];
        
        % estimate matrix size
        s = size(raw,1)/4 - 10;
        if s < 1
            s = 1;
        end
        % preallocate matrices
        Q = zeros(3*s, 6);
        d = zeros(3*s, 1);
        
        line = from;
        i=1;
        while line < to
            [D time line] = parseData(line, raw, n);
            
            Ri = frame(D(jointA,:));
            Rj = frame(D(jointB,:));

            %% very slow!
            %Q = [Q; [(Ri') (-Rj')]];
            %d = [d; (D(jointA, 1:3) - D(jointB, 1:3))'];
            
            Q(i:(i+2),:) = [(Ri') (-Rj')];
            d(i:(i+2),:) = (D(jointA, 1:3) - D(jointB, 1:3))';
            i=i+3;
        end
     
        % use singular value decomp
        [U,S,V] = svd(Q,0);
        
        dp = U'*d;
        y = dp./diag(S);
        solution = V*y;
        
        % compute RMS error
        %diag(S)
        epsvec = Q*solution - d;     
        eps = sqrt(mean(epsvec.*epsvec));
        
        G(jointA,jointB) = eps;       
    end
end

end