function [C L] = inferBoneMetrics(raw, P, n, from, to)
% infers the skeleton measures of motion data, given the parent
% relationship

C=zeros(n,3);
L=zeros(n,3);
for joint = 1:n
    if P(joint) ~= 0
        %% very slow!
        %Q=[];
        %d=[];
        
        % estimate matrix size
        s = size(raw,1)/4 - 10;
        if s < 1
            s = 1;
        end
        % preallocate matrices
        Q = zeros(3*s, 6);
        d = zeros(3*s, 1);
        
        line = from;
        i=1;
        while line < to
            [D time line] = parseData(line, raw, n);
            
            Ri = frame(D(joint,:));
            Rj = frame(D(P(joint),:));

            %Q = [Q; [(Ri') (-Rj')]];
            %d = [d; (D(joint, 1:3)' - D(P(joint), 1:3)')];
            Q(i:(i+2),:) = [(Ri') (-Rj')];
            d(i:(i+2),:) = (D(joint, 1:3) - D(P(joint), 1:3))';
            i=i+3;            
        end
        % use singular value decomp
        [U,S,V] = svd(Q,0);
        
        dp = U'*d;
        y = dp./diag(S);
        solution = V*y;
                
        %solution = Q\d;
        C(joint,:) = solution(1:3)';
        L(joint,:) = solution(4:6)';    
    end
end

end

