function [C L] = inferBoneMetrics(raw, P, n, from, to)
% infers the skeleton measures of motion data, given the parent
% relationship

C=zeros(n,3);
L=zeros(n,3);
for joint = 1:n
    if P(joint) ~= 0
        Q=[];
        d=[];
        line = from;
        while line < to
            [D time line] = makeframe(line, raw, n);

            %Ri = makeRotationMatrix(D(joint, 4), D(joint, 5), D(joint, 6));
            %Rj = makeRotationMatrix(D(P(joint), 4), D(P(joint), 5), D(P(joint), 6));
            
            Ri = frame(D(joint,:));
            Rj = frame(D(P(joint,:)));

            Q = [Q; [(Ri') (-Rj')]];
            d = [d; (D(joint, 1:3)' - D(P(joint), 1:3)')];
        end
        % use singular value decomp
        [U,S,V] = svd(Q,0);
        
        dp = U'*d;
        y = dp./diag(S);
        solution = V*y;
        
        %diag(S)
%        epsvec = Q*solution - d;        
%        eps = sqrt(mean(epsvec.*epsvec))
        
        %solution = Q\d;
        C(joint,:) = solution(1:3)';
        L(joint,:) = solution(4:6)';    
    end
end

end

