function show_Calibrated(filename, root)

data=[];
data = load(filename, '-ascii');

n = guessNumSensors(data)

if nargin < 2
    root = n;
end

[p C L] = inferSkeleton(data, n, root);

drawAnimation(data, n, C, L, p);

end

function [p C L] = inferSkeleton(data, n, root)
   G = inferBoneGraph(data, n, 1, size(data,1))
   p = prim(G+G', root)
   [C L] = inferBoneMetrics(data, p, n, 1, size(data,1));
end

function n = guessNumSensors(data)
   s = size(data,1);
   if s > 1000
       s = 1000;
   end
   n = max(data(1:s, 3))+1;
end